unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls,
  gfx_files  ,
  XComun,UFPuntuales,
  ToolWin, StdCtrls, ImgList;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Editar1: TMenuItem;
    FPuntuales1: TMenuItem;
    Abrir1: TMenuItem;
    Salvar1: TMenuItem;
    N1: TMenuItem;
    Salir1: TMenuItem;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Negativo1: TMenuItem;
    Grises1: TMenuItem;
    Umbralizar1: TMenuItem;
    Deshacer1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    SaveDialog1: TSaveDialog;
    UmbralizaraU1: TMenuItem;
    Image2: TImage;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Deshacer1Click(Sender: TObject);
    procedure Grises1Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton; Shift:
        TShiftState; X, Y: Integer);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton; Shift:
        TShiftState; X, Y: Integer);
    procedure Negativo1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Umbralizar1Click(Sender: TObject);
    procedure UmbralizaraU1Click(Sender: TObject);
  private
    { Private declarations }
    EKan  : string;
    bsel  : boolean;

    procedure Mostrar(BM : TBitMap; Image : TImage);
  public
    { Public declarations }
    M1,M2    : XComun.XMat;
    BM1,BMS  : TBitMap;
  end;

var
  Form1: TForm1;

implementation

uses ULectR;


{$R *.dfm}


procedure TForm1.Mostrar(BM : TBitMap; Image : TImage);
begin
  Image.Picture.Assign(BM);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BM1  := TBitMap.Create;
  BMS  := TBitMap.Create;

  Panel1.Left  := 3;
  Panel1.Width := Form1.ClientWidth-6;
  EKan := 'RGB';
  StatusBar1.Panels[5].Text := EKan;

  BMS.Transparent        := true;
  BMS.TransparentColor   := clRed;
  BMS.canvas.Brush.Color := clRed;
  BMS.canvas.Pen.Color   := clRed;

  BMS.Width  := 1;
  BMS.Height := 1;
  BMS.Canvas.Rectangle(0,0,1,1);
  Image2.Picture.Assign(BMS);

  bsel := false;
end;



// Abrir
procedure TForm1.Abrir1Click(Sender: TObject);
var
  nom : string;
begin

  OpenDialog1.Filter := gfx_files._OpenFilterString;
  if OpenDialog1.Execute() then begin
    nom := OpenDialog1.FileName;
    gfx_files.LoadAnyImageToBMP(BM1,nom,false,0,0);
    UG_BM2Mat(BM1,M1);
    M2.nc :=0;

    Image1.Picture.Assign(BM1);
    BMS.Width  := M1.nc;
    BMS.Height := M1.nr;

    BMS.canvas.Pen.Color   := clRed;
    BMS.Canvas.Rectangle(0,0,M1.nc,M1.nr);
    BMS.canvas.Pen.Color   := clYellow;

    Image2.Picture.Assign(BMS);
    _x1 := 0      ; _y1 := 0;
    _x2 := M1.nc  ; _y2 := M1.nr;

    bsel := false;

  end;
end;

// Salvar
procedure TForm1.Salvar1Click(Sender: TObject);
var
  nom : string;
begin

  SaveDialog1.Filter := gfx_files._SaveFilterString;
  if SaveDialog1.Execute then begin
    nom := SaveDialog1.FileName;
    gfx_files.SaveBMPToAnyFile(BM1,nom,0,0);
  end;
end;

// moverse sobre la imagen2 y leer sobre la imagen1
procedure TForm1.Image2MouseMove(Sender: TObject;
          Shift: TShiftState;
          X, Y : Integer);
var
  col,r,g,b : integer;
begin
  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  col := Image1.Canvas.Pixels[X,Y];
  r   := GetRValue(col);
  g   := GetGValue(col);
  b   := GetBValue(col);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);
end;

// capturar primer punto
procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton; Shift:
    TShiftState; X, Y: Integer);
begin
  if bsel then begin
    BMS.canvas.Pen.Color   := clRed;
    BMS.canvas.Rectangle(_x1,_y1, _x2, _y2);
    Image2.Picture.Assign(BMS);

    _x1 := X; _y1 := Y;
  end;
end;

// capturar segundo punto y dibujar rectangulo
procedure TForm1.Image2MouseUp(Sender: TObject; Button: TMouseButton; Shift:
    TShiftState; X, Y: Integer);
begin
  if bsel then begin
    _x2 := X; _y2 := Y;

    BMS.canvas.Pen.Color   := clYellow;
    BMS.Canvas.Rectangle(_x1,_y1, _x2,_y2);

    Image2.Picture.Assign(BMS);
  end;
end;


// ------------------- Otros procesos

// Deshacer
procedure TForm1.Deshacer1Click(Sender: TObject);
begin
  if (M2.nc<>0) and (M2.nr<>0) then begin
    UG_SwapM(M1,M2);
    UG_Mat2BM(M2,BM1);
    Mostrar(BM1,Image1);
  end;
end;

// Elegir Canales
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  _kan [0] := CheckBox1.Checked;
  if _kan[0]
    then EKan[1] := 'R'
    else EKan[1] := '-';

  StatusBar1.Panels[5].Text := EKan;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  _kan [1] := CheckBox2.Checked;
  if _kan[1]
    then EKan[2] := 'G'
    else EKan[2] := '-';

  StatusBar1.Panels[5].Text := EKan;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  _kan [2] := CheckBox3.Checked;
  if _kan[2]
    then EKan[3] := 'B'
    else EKan[3] := '-';

  StatusBar1.Panels[5].Text := EKan;
end;

// ------------------- Filtros Puntuales


// Negativo
procedure TForm1.Negativo1Click(Sender: TObject);
begin
  if (M2.nc<>0) and (M2.nr<>0) then UG_CopiaM2M(M2,M1);
  XFP_Neg(M1,M2);
  UG_Mat2BM(M2,BM1);
  Mostrar(BM1,Image1);
end;

// Grises
procedure TForm1.Grises1Click(Sender: TObject);
begin
  if (M2.nc<>0) and (M2.nr<>0) then UG_CopiaM2M(M2,M1);
  XFP_Gris(M1,M2);
  UG_Mat2BM(M2,BM1);
  Mostrar(BM1,Image1);
end;

// seleccionar
procedure TForm1.ToolButton5Click(Sender: TObject);
begin
  bsel := true;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
  BMS.canvas.Pen.Color   := clRed;
  BMS.canvas.Rectangle(_x1,_y1, _x2, _y2);
  Image2.Picture.Assign(BMS);

  bsel := false;
  _x1 := 0;
  _y1 := 0;
  _x2 := M1.nc;
  _y2 := M1.nr;

end;


// Umbraliza lambda/2
procedure TForm1.Umbralizar1Click(Sender: TObject);
begin
  if (M2.nc<>0) and (M2.nr<>0) then UG_CopiaM2M(M2,M1);
  XFP_Umbral(M1,M2);
  UG_Mat2BM(M2,BM1);
  Mostrar(BM1,Image1);
end;

// Umbraliza a un valor U
procedure TForm1.UmbralizaraU1Click(Sender: TObject);
var
  u   : single;
  err : integer;
begin
  if (M2.nc<>0) and (M2.nr<>0) then UG_CopiaM2M(M2,M1);

  // prepara
  Form2.Label1.Caption := 'Valor de Umbral';
  Form2.Edit1.Text     := '127.5';
  Form2.ShowModal;
  val(Form2.Edit1.Text,u,err);
  if err <> 0 then begin
    ShowMessage('Error de entrada en U');
    exit;
  end;
  // Accin
  u := 100;
  XFP_Umbral(M1,M2, u);
  UG_Mat2BM(M2,BM1);
  Mostrar(BM1,Image1);
end;


end.
